﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Configuration.Install;
using System.Security;
using System.Security.Permissions;
using Microsoft.VisualStudio.Tools.Office.Runtime.Security;

namespace InclusionListCustomActions
{
    [RunInstaller(true)]
    [ToolboxItem(false)]
    public class TrustInstaller
        : Installer
    {
        const string RSA_PublicKey = "<RSAKeyValue><Modulus>r9HG1wbAxcVOJ1EzgVGsUfYe3Pyc9sb4TWlo6smv72/+ebnvQmTfU9bD6C8KBv5i/FcnQKbybdk8auH65blF9m96XTHiCw+ZFeupBhRz1SLN/WpUmE8Zv7I4pkbBmkvxaBvziYBU31CHPMYaTq+gWtGu1d7z2JTWXkMcRlu+P20=</Modulus><Exponent>AQAB</Exponent></RSAKeyValue>";
				
        public override void Install(IDictionary stateSaver)
        {
            try
            {
                SecurityPermission permission =
                    new SecurityPermission(PermissionState.Unrestricted);
                permission.Demand();
            }
            catch (SecurityException)
            {
                throw new InstallException(
                    "You have insufficient privileges to " +
                    "register a trust relationship. Start Excel " +
                    "and confirm the trust dialog to run the addin.");
            }
            Uri deploymentManifestLocation = null;
            if (Uri.TryCreate(Context.Parameters["deploymentManifestLocation"],
                UriKind.RelativeOrAbsolute, out deploymentManifestLocation) == false)
            {
                throw new InstallException(
                    "The location of the deployment manifest is missing or invalid.");
            }
            AddInSecurityEntry entry = new AddInSecurityEntry(
                            deploymentManifestLocation, RSA_PublicKey);
            UserInclusionList.Add(entry);
            stateSaver.Add("entryKey", deploymentManifestLocation);
        }

        public override void Uninstall(IDictionary savedState)
        {
            Uri deploymentManifestLocation = (Uri)savedState["entryKey"];
            if (deploymentManifestLocation != null)
            {
                UserInclusionList.Remove(deploymentManifestLocation);
            }
        }
    }
}
